﻿local function eventHandler(self, event, ...)
    if event == "ZONE_CHANGED_NEW_AREA" then
		TextZone = GetZoneText();
		IdZone = GetCurrentMapAreaID();
		
		if TestingZone(IdZone) then
			IdCAT = Equality(IdZone);
		    SaveTrackList()
		    CleanTrackList()
			AchievListZone(IdCAT)
		elseif not (TRACKED == nil) then
			CleanTrackList()
			for i=1,#TRACKED do
				AddTrackedAchievement(TRACKED[i])
			end
			TRACKED = nil;
		end
	end
end

function AutoTrackerAchievement_OnLoad(self)
    print("Achievement Tracker : OK");
    self:RegisterEvent("ADDON_LOADED");
    self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
    self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:SetScript("OnEvent", eventHandler);
end

function TestingZone(IdZone)
	-- Battleground
	if IdZone == 461 then return true end -- "Arathi Basin"
	if IdZone == 401 then return true end -- "Alterac Valley"
	if IdZone == 482 then return true end -- "Eye of the Storm"
	if IdZone == 443 then return true end -- "Warsong Gulch"
	if IdZone == 512 then return true end -- "Strand of the Ancients"
	if IdZone == 501 then return true end -- "Wintergrasp"
	if IdZone == 540 then return true end -- "Isle of Conquest"
	if IdZone == 736 then return true end -- "Battle for Gilneas"
	if IdZone == 626 then return true end -- "Twin Peaks"
	if IdZone == 708 then return true end -- "Tol Barad"
	-- ARENA
	if IdZone == 14221 then return true end -- "Ruins of Lordaeron" -- ARENA
	if IdZone == 30301 then return true end -- "Blade's Edge Arena" -- ARENA
	if IdZone == 14221 then return true end -- "Dalaran Arena" -- ARENA
	if IdZone == 31121 then return true end -- "Nagrand Arena" -- ARENA
	if IdZone == 14221 then return true end -- "The Ring of Valor" -- ARENA
	-- Darkmoon Fair
	if IdZone == 823 then return true end
  return false
end

function Equality(IdZone)
	-- Battleground
	if IdZone == 461 then return 14802 end -- "Arathi Basin"
	if IdZone == 401 then return 14801 end -- "Alterac Valley"
	if IdZone == 482 then return 14803 end -- "Eye of the Storm"
	if IdZone == 443 then return 14804 end -- "Warsong Gulch"
	if IdZone == 512 then return 14881 end -- "Strand of the Ancients"
	if IdZone == 501 then return 14901 end -- "Wintergrasp"
	if IdZone == 540 then return 15003 end -- "Isle of Conquest"
	if IdZone == 736 then return 15073 end -- "Battle for Gilneas"
	if IdZone == 626 then return 15074 end -- "Twin Peaks"
	if IdZone == 708 then return 15075 end -- "Tol Barad"
	-- ARENA
	if IdZone == 14221 then return 165 end -- "Ruins of Lordaeron" -- ARENA
	if IdZone == 30301 then return 165 end -- "Arène des tranchantes" -- ARENA
	if IdZone == 14221 then return 165 end -- "Egouts de Dalaran" -- ARENA
	if IdZone == 31121 then return 165 end -- "Arena of Nagrand" -- ARENA
	if IdZone == 14221 then return 165 end -- "Arena of Valor" -- ARENA
	-- Darkmoon Fair
	if IdZone == 823 then return 15101 end
end

function CleanTrackList() 
	local achievlisted = {GetTrackedAchievements()};	
	for i=1,#achievlisted do
		RemoveTrackedAchievement(achievlisted[i])
	end
end

function SaveTrackList()
  if (not TRACKED) then
    TRACKED = {GetTrackedAchievements()};
    for i=1,#TRACKED do
    end
  else
  end
end

-- Print the incomplete achievements and and them to the tracking list
function AchievListZone(IdCAT)
  local n
  local currentlytracked = 0
  local incomplete = false
  ACHIEVS_LIST = GetCategoryList();
  for i,id in ipairs(ACHIEVS_LIST) do
    n, parentID = GetCategoryInfo(id) -- récupère titre et idsup via Id de catégorie
    if (IdCAT == id) then  
        print ("Checking incomplete achievements for " .. n)
		print("id = " .. id);
        for j = 1, GetCategoryNumAchievements(id) do
			aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(id,j)
			if not completed then
				print (GetAchievementLink(aid));
  		        if currentlytracked < 10 then
				  AddTrackedAchievement(aid);
				  currentlytracked = currentlytracked +1
				end
				incomplete = true
			end
        end
    end
  end
  return incomplete
end
